import { HttpClient } from '@angular/common/http';
import { EditResult, HostStoreInfo, QueryResult } from '@yukawa/chain-base-angular-domain';
import { Account, Credentials } from './chain-security-angular-domain';
import { Observable } from 'rxjs';
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.security.flux.rest.AccountFluxController <br/>
*/
export declare class AccountService {
    httpService: HttpClient;
    constructor(httpService: HttpClient);
    deleteAccount(id: string): Observable<EditResult>;
    editAccount(value: Account): Observable<EditResult>;
    findAccounts(): Observable<Account[]>;
    loadAccount(id: string): Observable<Account>;
    queryAccounts(filter?: any): Observable<QueryResult<Account>>;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.security.flux.rest.OAuthFluxController <br/>
*/
export declare class OAuthService {
    httpService: HttpClient;
    constructor(httpService: HttpClient);
    /**
    *	crate new auth + refresh token
    */
    oAuthToken(): Observable<any>;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.security.flux.rest.SecurityAdminRest <br/>
*/
export declare class SecurityAdminRest {
    httpService: HttpClient;
    constructor(httpService: HttpClient);
    getAccountMeta(): Observable<HostStoreInfo[]>;
    /**
    *	kill switch - revoke all before
    */
    revokeAllTokens(cutOff: string): Observable<string>;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.security.flux.rest.SecurityModuleRest <br/>
*/
export declare class SecurityModuleRest {
    httpService: HttpClient;
    constructor(httpService: HttpClient);
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.security.flux.rest.TokenAuthFluxController <br/>
*/
export declare class TokenAuthService {
    httpService: HttpClient;
    constructor(httpService: HttpClient);
    /**
    *	crate new auth + refresh token
    */
    createToken(arg0: Credentials): Observable<any>;
    /**
    *	logged in user details
    */
    loadAccount(): Observable<any>;
    /**
    *	refresh access token
    */
    refreshToken(): Observable<{
        [key: string]: Object;
    }>;
    revokeToken(): Observable<EditResult>;
}
