import { HttpHeaders, HttpClient, HttpParams } from '@angular/common/http';
import { Injectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.domain.AccessToken <br/>
 * @record
 * @template C
 */
function AccessToken() { }
if (false) {
    /** @type {?|undefined} */
    AccessToken.prototype.claims;
    /** @type {?|undefined} */
    AccessToken.prototype.details;
    /** @type {?|undefined} */
    AccessToken.prototype.expiration;
    /** @type {?|undefined} */
    AccessToken.prototype.id;
    /** @type {?|undefined} */
    AccessToken.prototype.issuedAt;
    /** @type {?|undefined} */
    AccessToken.prototype.roles;
    /** @type {?|undefined} */
    AccessToken.prototype.subject;
    /** @type {?|undefined} */
    AccessToken.prototype.token;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.domain.Account <br/>
 * @record
 */
function Account() { }
if (false) {
    /** @type {?|undefined} */
    Account.prototype.credentials;
    /** @type {?|undefined} */
    Account.prototype.details;
    /** @type {?|undefined} */
    Account.prototype.roles;
    /** @type {?|undefined} */
    Account.prototype.status;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.domain.AccountStatus <br/>
 * @record
 */
function AccountStatus() { }
if (false) {
    /** @type {?|undefined} */
    AccountStatus.prototype.accountNonExpired;
    /** @type {?|undefined} */
    AccountStatus.prototype.accountNonLocked;
    /** @type {?|undefined} */
    AccountStatus.prototype.credentialsNonExpired;
    /** @type {?|undefined} */
    AccountStatus.prototype.enabled;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.domain.Credentials <br/>
 * @record
 */
function Credentials() { }
if (false) {
    /**
     * \@example admin
     * @type {?}
     */
    Credentials.prototype.password;
    /**
     * \@example admin
     * @type {?}
     */
    Credentials.prototype.username;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.domain.RoleInfo <br/>
 * @record
 */
function RoleInfo() { }
if (false) {
    /**
     * \@example materials
     * @type {?|undefined}
     */
    RoleInfo.prototype.scope;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.flux.rest.AccountFluxController <br/>
 */
class AccountService {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
    }
    /**
     * @param {?} id
     * @return {?}
     */
    deleteAccount(id) {
        return this.httpService.delete('/accounts/' + id + '');
    }
    /**
     * @param {?} value
     * @return {?}
     */
    editAccount(value) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.put('/accounts', value, { headers });
    }
    /**
     * @return {?}
     */
    findAccounts() {
        return this.httpService.get('/accounts');
    }
    /**
     * @param {?} id
     * @return {?}
     */
    loadAccount(id) {
        return this.httpService.get('/accounts/' + id + '');
    }
    /**
     * @param {?=} filter
     * @return {?}
     */
    queryAccounts(filter) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('/accounts/query', filter, { headers });
    }
}
AccountService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
AccountService.ctorParameters = () => [
    { type: HttpClient }
];
if (false) {
    /** @type {?} */
    AccountService.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.flux.rest.OAuthFluxController <br/>
 */
class OAuthService {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
    }
    /**
     * 	crate new auth + refresh token
     * @return {?}
     */
    oAuthToken() {
        return this.httpService.post('/oauth/token', null);
    }
}
OAuthService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
OAuthService.ctorParameters = () => [
    { type: HttpClient }
];
if (false) {
    /** @type {?} */
    OAuthService.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.flux.rest.SecurityAdminRest <br/>
 */
class SecurityAdminRest {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
    }
    /**
     * @return {?}
     */
    getAccountMeta() {
        return this.httpService.get('/admin/meta');
    }
    /**
     * 	kill switch - revoke all before
     * @param {?} cutOff
     * @return {?}
     */
    revokeAllTokens(cutOff) {
        /** @type {?} */
        const queryParamsList = [];
        queryParamsList.push({ name: 'cutOff', value: cutOff });
        /** @type {?} */
        let params = new HttpParams();
        for (const queryParam of queryParamsList) {
            params = params.append(queryParam.name, queryParam.value);
        }
        return this.httpService.put('/admin/revoke', null, { params });
    }
}
SecurityAdminRest.decorators = [
    { type: Injectable }
];
/** @nocollapse */
SecurityAdminRest.ctorParameters = () => [
    { type: HttpClient }
];
if (false) {
    /** @type {?} */
    SecurityAdminRest.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.flux.rest.SecurityModuleRest <br/>
 */
class SecurityModuleRest {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
    }
}
SecurityModuleRest.decorators = [
    { type: Injectable }
];
/** @nocollapse */
SecurityModuleRest.ctorParameters = () => [
    { type: HttpClient }
];
if (false) {
    /** @type {?} */
    SecurityModuleRest.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.flux.rest.TokenAuthFluxController <br/>
 */
class TokenAuthService {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
    }
    /**
     * 	crate new auth + refresh token
     * @param {?} arg0
     * @return {?}
     */
    createToken(arg0) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('/auth/token', arg0, { headers });
    }
    /**
     * 	logged in user details
     * @return {?}
     */
    loadAccount() {
        return this.httpService.get('/auth/account');
    }
    /**
     * 	refresh access token
     * @return {?}
     */
    refreshToken() {
        return this.httpService.get('/auth/refresh');
    }
    /**
     * @return {?}
     */
    revokeToken() {
        return this.httpService.delete('/auth/refresh');
    }
}
TokenAuthService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
TokenAuthService.ctorParameters = () => [
    { type: HttpClient }
];
if (false) {
    /** @type {?} */
    TokenAuthService.prototype.httpService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AccountService, OAuthService, SecurityAdminRest, SecurityModuleRest, TokenAuthService };
//# sourceMappingURL=yukawa-chain-security-angular-core.js.map
