import { __values } from 'tslib';
import { HttpHeaders, HttpClient, HttpParams } from '@angular/common/http';
import { Injectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.domain.AccessToken <br/>
 * @record
 * @template C
 */
function AccessToken() { }
if (false) {
    /** @type {?|undefined} */
    AccessToken.prototype.claims;
    /** @type {?|undefined} */
    AccessToken.prototype.details;
    /** @type {?|undefined} */
    AccessToken.prototype.expiration;
    /** @type {?|undefined} */
    AccessToken.prototype.id;
    /** @type {?|undefined} */
    AccessToken.prototype.issuedAt;
    /** @type {?|undefined} */
    AccessToken.prototype.roles;
    /** @type {?|undefined} */
    AccessToken.prototype.subject;
    /** @type {?|undefined} */
    AccessToken.prototype.token;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.domain.Account <br/>
 * @record
 */
function Account() { }
if (false) {
    /** @type {?|undefined} */
    Account.prototype.credentials;
    /** @type {?|undefined} */
    Account.prototype.details;
    /** @type {?|undefined} */
    Account.prototype.roles;
    /** @type {?|undefined} */
    Account.prototype.status;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.domain.AccountStatus <br/>
 * @record
 */
function AccountStatus() { }
if (false) {
    /** @type {?|undefined} */
    AccountStatus.prototype.accountNonExpired;
    /** @type {?|undefined} */
    AccountStatus.prototype.accountNonLocked;
    /** @type {?|undefined} */
    AccountStatus.prototype.credentialsNonExpired;
    /** @type {?|undefined} */
    AccountStatus.prototype.enabled;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.domain.Credentials <br/>
 * @record
 */
function Credentials() { }
if (false) {
    /**
     * \@example admin
     * @type {?}
     */
    Credentials.prototype.password;
    /**
     * \@example admin
     * @type {?}
     */
    Credentials.prototype.username;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.domain.RoleInfo <br/>
 * @record
 */
function RoleInfo() { }
if (false) {
    /**
     * \@example materials
     * @type {?|undefined}
     */
    RoleInfo.prototype.scope;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.flux.rest.AccountFluxController <br/>
 */
var AccountService = /** @class */ (function () {
    function AccountService(httpService) {
        this.httpService = httpService;
    }
    /**
     * @param {?} id
     * @return {?}
     */
    AccountService.prototype.deleteAccount = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.httpService.delete('/accounts/' + id + '');
    };
    /**
     * @param {?} value
     * @return {?}
     */
    AccountService.prototype.editAccount = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.put('/accounts', value, { headers: headers });
    };
    /**
     * @return {?}
     */
    AccountService.prototype.findAccounts = /**
     * @return {?}
     */
    function () {
        return this.httpService.get('/accounts');
    };
    /**
     * @param {?} id
     * @return {?}
     */
    AccountService.prototype.loadAccount = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.httpService.get('/accounts/' + id + '');
    };
    /**
     * @param {?=} filter
     * @return {?}
     */
    AccountService.prototype.queryAccounts = /**
     * @param {?=} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('/accounts/query', filter, { headers: headers });
    };
    AccountService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    AccountService.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    return AccountService;
}());
if (false) {
    /** @type {?} */
    AccountService.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.flux.rest.OAuthFluxController <br/>
 */
var OAuthService = /** @class */ (function () {
    function OAuthService(httpService) {
        this.httpService = httpService;
    }
    /**
    *	crate new auth + refresh token
    */
    /**
     * 	crate new auth + refresh token
     * @return {?}
     */
    OAuthService.prototype.oAuthToken = /**
     * 	crate new auth + refresh token
     * @return {?}
     */
    function () {
        return this.httpService.post('/oauth/token', null);
    };
    OAuthService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    OAuthService.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    return OAuthService;
}());
if (false) {
    /** @type {?} */
    OAuthService.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.flux.rest.SecurityAdminRest <br/>
 */
var SecurityAdminRest = /** @class */ (function () {
    function SecurityAdminRest(httpService) {
        this.httpService = httpService;
    }
    /**
     * @return {?}
     */
    SecurityAdminRest.prototype.getAccountMeta = /**
     * @return {?}
     */
    function () {
        return this.httpService.get('/admin/meta');
    };
    /**
    *	kill switch - revoke all before
    */
    /**
     * 	kill switch - revoke all before
     * @param {?} cutOff
     * @return {?}
     */
    SecurityAdminRest.prototype.revokeAllTokens = /**
     * 	kill switch - revoke all before
     * @param {?} cutOff
     * @return {?}
     */
    function (cutOff) {
        var e_1, _a;
        /** @type {?} */
        var queryParamsList = [];
        queryParamsList.push({ name: 'cutOff', value: cutOff });
        /** @type {?} */
        var params = new HttpParams();
        try {
            for (var queryParamsList_1 = __values(queryParamsList), queryParamsList_1_1 = queryParamsList_1.next(); !queryParamsList_1_1.done; queryParamsList_1_1 = queryParamsList_1.next()) {
                var queryParam = queryParamsList_1_1.value;
                params = params.append(queryParam.name, queryParam.value);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (queryParamsList_1_1 && !queryParamsList_1_1.done && (_a = queryParamsList_1.return)) _a.call(queryParamsList_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return this.httpService.put('/admin/revoke', null, { params: params });
    };
    SecurityAdminRest.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    SecurityAdminRest.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    return SecurityAdminRest;
}());
if (false) {
    /** @type {?} */
    SecurityAdminRest.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.flux.rest.SecurityModuleRest <br/>
 */
var SecurityModuleRest = /** @class */ (function () {
    function SecurityModuleRest(httpService) {
        this.httpService = httpService;
    }
    SecurityModuleRest.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    SecurityModuleRest.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    return SecurityModuleRest;
}());
if (false) {
    /** @type {?} */
    SecurityModuleRest.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.security.flux.rest.TokenAuthFluxController <br/>
 */
var TokenAuthService = /** @class */ (function () {
    function TokenAuthService(httpService) {
        this.httpService = httpService;
    }
    /**
    *	crate new auth + refresh token
    */
    /**
     * 	crate new auth + refresh token
     * @param {?} arg0
     * @return {?}
     */
    TokenAuthService.prototype.createToken = /**
     * 	crate new auth + refresh token
     * @param {?} arg0
     * @return {?}
     */
    function (arg0) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('/auth/token', arg0, { headers: headers });
    };
    /**
    *	logged in user details
    */
    /**
     * 	logged in user details
     * @return {?}
     */
    TokenAuthService.prototype.loadAccount = /**
     * 	logged in user details
     * @return {?}
     */
    function () {
        return this.httpService.get('/auth/account');
    };
    /**
    *	refresh access token
    */
    /**
     * 	refresh access token
     * @return {?}
     */
    TokenAuthService.prototype.refreshToken = /**
     * 	refresh access token
     * @return {?}
     */
    function () {
        return this.httpService.get('/auth/refresh');
    };
    /**
     * @return {?}
     */
    TokenAuthService.prototype.revokeToken = /**
     * @return {?}
     */
    function () {
        return this.httpService.delete('/auth/refresh');
    };
    TokenAuthService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    TokenAuthService.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    return TokenAuthService;
}());
if (false) {
    /** @type {?} */
    TokenAuthService.prototype.httpService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AccountService, OAuthService, SecurityAdminRest, SecurityModuleRest, TokenAuthService };
//# sourceMappingURL=yukawa-chain-security-angular-core.js.map
